

function createMenu()

	-- Data storeage

	local MenuBackcolor = Turbine.UI.Color(0.0, 0.0, 0.0);

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();

	--local menuMaxHeight = (screenHeight / 2);
	local menuMaxHeight = 200;
	local menuCurHeight = 0;
	local menuCurTop = 3;

	local i = 1;
	local mCounter = 1;
	local lineHeight = 25; -- Height of each line in the menu.
	local linebuffer = 3;
	local menuWidth = 100;

	-------------------------------------------------------------------------
	-- Windows

	winMenuParent = Turbine.UI.Window();
	winMenuParent:SetBackColor(MenuBackcolor);
	winMenuParent:SetMouseVisible(true);
	winMenuParent:SetOpacity(0);
	winMenuParent:SetPosition(0,0);
	winMenuParent:SetSize(screenWidth,screenHeight);
	winMenuParent:SetVisible(false);
	winMenuParent:SetZOrder(198);

	winMenuBody = Turbine.UI.Window();
	winMenuBody:SetParent(winMenuParent);
	winMenuBody:SetBackColor(MenuBackcolor);
	winMenuBody:SetMouseVisible(true);
	winMenuBody:SetOpacity(0.8);
	winMenuBody:SetVisible(true);
	winMenuBody:SetWidth(menuWidth);
	winMenuBody:SetZOrder(199);

	winMenuHolder = Turbine.UI.Control();
	winMenuHolder:SetParent(winMenuBody);
	winMenuHolder:SetBackColor(MenuBackcolor);
	winMenuHolder:SetMouseVisible(true);
	winMenuHolder:SetOpacity(0);
	winMenuHolder:SetVisible(true);
	winMenuHolder:SetWidth(menuWidth);
	winMenuHolder:SetZOrder(200);

	scrollBar = Turbine.UI.ScrollBar();
	scrollBar:SetParent(winMenuBody);
	scrollBar:SetTop(0);
	scrollBar:SetZOrder(201);
	scrollBar:SetMinimum(0);
	scrollBar:SetWidth(15);
	scrollBar:SetValue(0);
	scrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);

	scrollIncBut = Turbine.UI.Button();
	scrollIncBut:SetSize(15,15);
	scrollIncBut:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_inc_up.tga");
	--scrollIncBut:SetParent(scrollBar);

	scrollDecBut = Turbine.UI.Button();
	scrollDecBut:SetSize(15,15);
	scrollDecBut:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_dec_up.tga");
	--scrollDecBut:SetParent(scrollBar);

	scrollThumb = Turbine.UI.Control();
	scrollThumb:SetSize(15,15);
	scrollThumb:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_thumb.tga");
	--scrollThumb:SetParent(scrollBar);

	scrollBar:SetDecrementButton(scrollDecBut);
	scrollBar:SetIncrementButton(scrollIncBut);
	scrollBar:SetThumbButton(scrollThumb);


	tChatCommands =
	{
		[1] =
		{
			["Name"] = "Advice";
			["Comm"] = "/advice";
			["Length"] = 50;
		};
		[2] =
		{
			["Name"] = "AFK";
			["Comm"] = "/afk";
			["Length"] = 30;
		};
		[3] =
		{
			["Name"] = "Emote";
			["Comm"] = "/emote";
			["Length"] = 48;
		};
		[4] =
		{
			["Name"] = "Fellowship";
			["Comm"] = "/f";
			["Length"] = 72;
		};
		[5] =
		{
			["Name"] = "Kinship";
			["Comm"] = "/k";
			["Length"] = 50;
		};
		[6] =
		{
			["Name"] = "LFF";
			["Comm"] = "/lff";
			["Length"] = 30;
		};
		[7] =
		{
			["Name"] = "OOC";
			["Comm"] = "/ooc";
			["Length"] = 35;
		};
		[8] =
		{
			["Name"] = "Officer";
			["Comm"] = "/o";
			["Length"] = 50;
		};
		[9] =
		{
			["Name"] = "Raid";
			["Comm"] = "/ra";
			["Length"] = 32;
		};
		[10] =
		{
			["Name"] = "Regional";
			["Comm"] = "/regional";
			["Length"] = 59;
		};
		[11] =
		{
			["Name"] = "Say";
			["Comm"] = "/say";
			["Length"] = 30;
		};
		[12] =
		{
			["Name"] = "Tell";
			["Comm"] = "/tell";
			["Length"] = 30;
		};
		[13] =
		{
			["Name"] = "Trade";
			["Comm"] = "/trade";
			["Length"] = 45;
		};
		[14] =
		{
			["Name"] = "World";
			["Comm"] = "/wd";
			["Length"] = 45;
		};
		[15] =
		{
			["Name"] = "UC1";
			["Comm"] = "/1";
			["Length"] = 30;
		};
		[16] =
		{
			["Name"] = "UC2";
			["Comm"] = "/2";
			["Length"] = 30;
		};
		[17] =
		{
			["Name"] = "UC3";
			["Comm"] = "/3";
			["Length"] = 30;
		};
		[18] =
		{
			["Name"] = "UC4";
			["Comm"] = "/4";
			["Length"] = 30;
		};
	};

	local numOfSlots = 17;


	winMenuItem = {};
	winMenuLabel = {};

	--------------------------------------------------------------------------
	-- This loop determines which gambits to add to the menu, and creates
	-- the menu on the fly.

	while i <= numOfSlots do -- loops through all the gambits in the table.

		local gName = tChatCommands[i].Name;

		winMenuItem[mCounter] = Turbine.UI.Control();
		winMenuItem[mCounter]:SetHeight(lineHeight);
		winMenuItem[mCounter]:SetLeft(linebuffer);
		winMenuItem[mCounter]:SetTop(menuCurTop);
		winMenuItem[mCounter]:SetWidth(menuWidth - (2 * linebuffer));
		winMenuItem[mCounter]:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));
		winMenuItem[mCounter]:SetOpacity(1);
		winMenuItem[mCounter]:SetMouseVisible(true);
		winMenuItem[mCounter]:SetParent(winMenuHolder);


		winMenuLabel[mCounter] = Turbine.UI.Label();
		winMenuLabel[mCounter]:SetParent(winMenuItem[mCounter]);
		winMenuLabel[mCounter]:SetHeight(lineHeight-4);
		winMenuLabel[mCounter]:SetLeft(0);
		winMenuLabel[mCounter]:SetTop(2);
		winMenuLabel[mCounter]:SetWidth(winMenuItem[mCounter]:GetWidth());
		winMenuLabel[mCounter]:SetText(gName);
		winMenuLabel[mCounter]:SetForeColor(Turbine.UI.Color(1,1,1));
		winMenuLabel[mCounter]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		winMenuLabel[mCounter]:SetMultiline(false);
		winMenuLabel[mCounter]:SetMouseVisible(false);


		------------------------------------------------------------------------------
		-- Mouse event handlers
		winMenuItem[mCounter].MouseEnter = function(sender, args)
			sender:SetBackColor(Turbine.UI.Color(0.0, 0.3, 0.3));
		end


		winMenuItem[mCounter].MouseLeave = function(sender, args)
			sender:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));
		end


		winMenuItem[mCounter].MouseClick = function(sender, args)
			-- This block of code will determine which WinMenuItem was
			-- clicked and return it's child controls so we can see
			-- which label child corresponds to it.
			local Children = sender:GetControls();
			local cCount = Children:GetCount();
			local label = Children:Get(cCount);
			local selItem = label:GetText();

			--loop through tables to find selected item
			local y = 1;

			while y <= numOfSlots do
				local selName = tChatCommands[y].Name;
				if selName == selItem then

					SetChannel(tChatCommands[y].Name,tChatCommands[y].Comm,tChatCommands[y].Length);

					break
				else
					y = y + 1;
				end

			end

			winMenuParent:SetVisible(false); -- Hide menu after click.

		end


		-- Click outside menu, close window.
		winMenuParent.MouseClick = function(sender, args)
			winMenuParent:SetVisible(false);
		end


		------------------------------------------------------------------------------
		-- Increments

		menuCurTop = menuCurTop + lineHeight + linebuffer;

		mCounter = mCounter + 1;
		menuCurHeight = menuCurTop;


		if menuCurHeight > menuMaxHeight then
			-- Do not make menu larger, instead add a scrollbar.
			winMenuBody:SetHeight(menuMaxHeight);
			winMenuBody:SetWidth(menuWidth + 16);
			winMenuHolder:SetHeight(menuCurHeight);

			scrollBar:SetLeft(menuWidth);
			scrollBar:SetMaximum(menuCurHeight - menuMaxHeight);
			scrollBar:SetHeight(menuMaxHeight);

			scrollIncBut:SetTop(scrollBar:GetHeight()-15);
			scrollDecBut:SetTop(0);
			scrollThumb:SetTop(15);
			scrollBar:SetVisible(true);

			local visiblePercent = menuMaxHeight / menuCurHeight;
			local thumbSize = (menuMaxHeight * visiblePercent) - 30;

			scrollThumb:SetHeight(thumbSize);
			scrollThumb:SetStretchMode(3);

			scrollBar:SetSmallChange(10);
			scrollBar:SetLargeChange(20);

			scrollBar.ValueChanged = function(sender, args)
				-- Move the Holder Window up/down depending on bar value.
				local thumbValue = scrollBar:GetValue();
				local holderTop = -(thumbValue);

				winMenuHolder:SetTop(holderTop);
			end

		else
			winMenuBody:SetHeight(menuCurHeight);
			winMenuBody:SetWidth(menuWidth);
			winMenuHolder:SetHeight(menuCurHeight);
			scrollBar:SetVisible(false);
		end

		-- increment i for loop.
		i = i + 1;

	end

end


-- This function will display the menu at the current mouse position,
-- repositioning it so it doesn't appear off-screen.
function displayMenu()

	createMenu();

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();
	local menuHeight = winMenuBody:GetHeight();
	local menuWidth = winMenuBody:GetWidth();

	if (initX + menuWidth) > screenWidth then
		-- Menu will appear off-screen to the left, so load it to the right
		-- of the mouse location.#
		winMenuBody:SetLeft(initX - menuWidth);
	else
		winMenuBody:SetLeft(initX);
	end

	if (initY + menuHeight) > (screenHeight - 75) then
		-- Menu will appear off-screen to the bottom, so load it to touch
		-- the bottom of the screen.
		winMenuBody:SetTop(screenHeight - menuHeight - 75);
	else
		winMenuBody:SetTop(initY);
	end

	scrollBar:SetValue(0);
	winMenuHolder:SetTop(0);

	winMenuParent:SetVisible(true);

end
